/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.collection.sets;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import net.ranides.assira.collection.iterators.IntListIterator;
import java.util.Comparator;
import java.util.NoSuchElementException;

/**
 * A type-specific red-black tree map implementation for primitive int keys.
 * 
 * <P>The iterators can be safely cast end a {@linkplain java.util.ListIterator list iterator}.
 */
@SuppressWarnings({
    "PMD.AvoidReassigningParameters",
    "PMD.ExcessiveClassLength"
})
public class AIntRBTreeSet extends AIntSortedSet implements java.io.Serializable {

    private static final long serialVersionUID = 1L;

    protected final boolean unique;
    
    /**
     * A reference to the root entry.
     */
    protected transient Node tree;
    /**
     * Number of elements in this set.
     */
    protected int count;
    /**
     * The entry of the first element of this set.
     */
    protected transient Node firstEntry;
    /**
     * The entry of the last element of this set.
     */
    protected transient Node lastEntry;
    
    /**
     * This vector remembers the path and the direction followed during the
     * current insertion. It suffices for about 2<sup>32</sup> entries.
     */
    protected transient boolean dirPath[];
    
    protected transient Node nodePath[];

    /**
     * Creates a new empty tree set with the given comparator.
     *
     * @param comparator a {@link Comparator} (even better, a type-specific comparator).
     */
    protected AIntRBTreeSet(Comparator<? super Integer> comparator, boolean unique) {
        super(comparator);
        this.tree = null;
        this.count = 0;
        this.unique = unique;
        allocatePaths();
    }

	@SuppressWarnings("unchecked")
    private void allocatePaths() {
        dirPath = new boolean[64];
        nodePath = new Node[64];
    }
    
    /**
     * Returns the entry corresponding to the given key, if it is in the tree;
     * <code>null</code>, otherwise.
     *
     * @param key the key to search for.
     * @return the corresponding entry, or <code>null</code> if no entry with
     * the given key exists.
     */
    final Node findNode(int key) {
        Node entry = tree;
        int cmp;
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return entry;
    }

    /**
     * Locates a key.
     *
     * @param key a key.
     * @return the last entry on a search for the given key; this will be the
     * given key, if it present; otherwise, it will be either the smallest
     * greater key or the greatest smaller key.
     */
    final Node locateNode(int key) {
        Node entry = tree;
		Node last = tree;
        int cmp = 0;
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            last = entry;
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return rewind(cmp == 0 ? entry : last, key);
    }
    
    private Node rewind(Node current, int value) {
        if(unique || current==null) {
            return current;
        }
        Node last;
        do {
            last = current;
            current = current.prev();
        } while(current!=null && compare(value, current.key) == 0);
        
        return last;
    }
    
    @SuppressWarnings("PMD")
    @Override
    public final boolean add(int key) {
        int maxDepth = 0;
        if (tree == null) { // The case of the empty tree is treated separately.
            count++;
            tree = lastEntry = firstEntry = new Node(key);
        } else {
            Node pnode = tree, enode;
            int cmp, i = 0;
            while (true) {
                cmp = compare(key, pnode.key);
                if (unique && cmp == 0) {
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return false;
                }
                nodePath[ i] = pnode;
                if (dirPath[ i++] = cmp > 0) {
                    if (pnode.succ()) {
                        count++;
                        enode = new Node(key);
                        if (pnode.right == null) {
                            lastEntry = enode;
                        }
                        enode.left = pnode;
                        enode.right = pnode.right;
                        pnode.right(enode);
                        break;
                    }
                    pnode = pnode.right;
                } else {
                    if (pnode.pred()) {
                        count++;
                        enode = new Node(key);
                        if (pnode.left == null) {
                            firstEntry = enode;
                        }
                        enode.right = pnode;
                        enode.left = pnode.left;
                        pnode.left(enode);
                        break;
                    }
                    pnode = pnode.left;
                }
            }
            maxDepth = i--;
            while (i > 0 && !nodePath[ i].black()) {
                if (!dirPath[ i - 1]) {
                    Node ynode = nodePath[ i - 1].right;
                    if (!nodePath[ i - 1].succ() && !ynode.black()) {
                        nodePath[ i].black(true);
                        ynode.black(true);
                        nodePath[ i - 1].black(false);
                        i -= 2;
                    } else {
                        Node xnode;
                        if (!dirPath[ i]) {
                            ynode = nodePath[ i];
                        } else {
                            xnode = nodePath[ i];
                            ynode = xnode.right;
                            xnode.right = ynode.left;
                            ynode.left = xnode;
                            nodePath[ i - 1].left = ynode;
                            if (ynode.pred()) {
                                ynode.pred(false);
                                xnode.succ(ynode);
                            }
                        }
                        xnode = nodePath[ i - 1];
                        xnode.black(false);
                        ynode.black(true);
                        xnode.left = ynode.right;
                        ynode.right = xnode;
                        if (i < 2) {
                            tree = ynode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = ynode;
                            } else {
                                nodePath[ i - 2].left = ynode;
                            }
                        }
                        if (ynode.succ()) {
                            ynode.succ(false);
                            xnode.pred(ynode);
                        }
                        break;
                    }
                } else {
                    Node ynode = nodePath[ i - 1].left;
                    if (!nodePath[ i - 1].pred() && !ynode.black()) {
                        nodePath[ i].black(true);
                        ynode.black(true);
                        nodePath[ i - 1].black(false);
                        i -= 2;
                    } else {
                        Node xnode;
                        if (dirPath[ i]) {
                            ynode = nodePath[ i];
                        } else {
                            xnode = nodePath[ i];
                            ynode = xnode.left;
                            xnode.left = ynode.right;
                            ynode.right = xnode;
                            nodePath[ i - 1].right = ynode;
                            if (ynode.succ()) {
                                ynode.succ(false);
                                xnode.pred(ynode);
                            }
                        }
                        xnode = nodePath[ i - 1];
                        xnode.black(false);
                        ynode.black(true);
                        xnode.right = ynode.left;
                        ynode.left = xnode;
                        if (i < 2) {
                            tree = ynode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = ynode;
                            } else {
                                nodePath[ i - 2].left = ynode;
                            }
                        }
                        if (ynode.pred()) {
                            ynode.pred(false);
                            xnode.succ(ynode);
                        }
                        break;
                    }
                }
            }
        }
        tree.black(true);
        // We clean up the node path, or we could have stale references later.
        while (maxDepth-- != 0) {
            nodePath[ maxDepth] = null;
        }
        return true;
    }

    @SuppressWarnings("PMD")
    @Override
    public boolean remove(int key) {
        if (tree == null) {
            return false;
        }
        Node pnode = tree;
        int cmp;
        int i = 0;
        final int kk = key;
        while (true) {
            if ((cmp = compare(kk, pnode.key)) == 0) {
                break;
            }
            dirPath[ i] = cmp > 0;
            nodePath[ i] = pnode;
            if (dirPath[ i++]) {
                if ((pnode = pnode.right()) == null) {
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return false;
                }
            } else {
                if ((pnode = pnode.left()) == null) {
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return false;
                }
            }
        }
        if (pnode.left == null) {
            firstEntry = pnode.next();
        }
        if (pnode.right == null) {
            lastEntry = pnode.prev();
        }
        if (pnode.succ()) {
            if (pnode.pred()) {
                if (i == 0) {
                    tree = pnode.left;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].succ(pnode.right);
                    } else {
                        nodePath[ i - 1].pred(pnode.left);
                    }
                }
            } else {
                pnode.prev().right = pnode.right;
                if (i == 0) {
                    tree = pnode.left;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].right = pnode.left;
                    } else {
                        nodePath[ i - 1].left = pnode.left;
                    }
                }
            }
        } else {
            boolean color;
            Node rnode = pnode.right;
            if (rnode.pred()) {
                rnode.left = pnode.left;
                rnode.pred(pnode.pred());
                if (!rnode.pred()) {
                    rnode.prev().right = rnode;
                }
                if (i == 0) {
                    tree = rnode;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].right = rnode;
                    } else {
                        nodePath[ i - 1].left = rnode;
                    }
                }
                color = rnode.black();
                rnode.black(pnode.black());
                pnode.black(color);
                dirPath[ i] = true;
                nodePath[ i++] = rnode;
            } else {
                Node snode;
                int j = i++;
                while (true) {
                    dirPath[ i] = false;
                    nodePath[ i++] = rnode;
                    snode = rnode.left;
                    if (snode.pred()) {
                        break;
                    }
                    rnode = snode;
                }
                dirPath[ j] = true;
                nodePath[ j] = snode;
                if (snode.succ()) {
                    rnode.pred(snode);
                } else {
                    rnode.left = snode.right;
                }
                snode.left = pnode.left;
                if (!pnode.pred()) {
                    pnode.prev().right = snode;
                    snode.pred(false);
                }
                snode.right(pnode.right);
                color = snode.black();
                snode.black(pnode.black());
                pnode.black(color);
                if (j == 0) {
                    tree = snode;
                } else {
                    if (dirPath[ j - 1]) {
                        nodePath[ j - 1].right = snode;
                    } else {
                        nodePath[ j - 1].left = snode;
                    }
                }
            }
        }
        int maxDepth = i;
        if (pnode.black()) {
            for (; i > 0; i--) {
                if (dirPath[ i - 1] && !nodePath[ i - 1].succ()
                        || !dirPath[ i - 1] && !nodePath[ i - 1].pred()) {
                    Node xnode = dirPath[ i - 1] ? nodePath[ i - 1].right : nodePath[ i - 1].left;
                    if (!xnode.black()) {
                        xnode.black(true);
                        break;
                    }
                }
                if (!dirPath[ i - 1]) {
                    Node wnode = nodePath[ i - 1].right;
                    if (!wnode.black()) {
                        wnode.black(true);
                        nodePath[ i - 1].black(false);
                        nodePath[ i - 1].right = wnode.left;
                        wnode.left = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        nodePath[ i] = nodePath[ i - 1];
                        dirPath[ i] = false;
                        nodePath[ i - 1] = wnode;
                        if (maxDepth == i++) {
                            maxDepth++;
                        }
                        wnode = nodePath[ i - 1].right;
                    }
                    if ((wnode.pred() || wnode.left.black())
                            && (wnode.succ() || wnode.right.black())) {
                        wnode.black(false);
                    } else {
                        if (wnode.succ() || wnode.right.black()) {
                            Node ynode = wnode.left;
                            ynode.black(true);
                            wnode.black(false);
                            wnode.left = ynode.right;
                            ynode.right = wnode;
                            wnode = nodePath[ i - 1].right = ynode;
                            if (wnode.succ()) {
                                wnode.succ(false);
                                wnode.right.pred(wnode);
                            }
                        }
                        wnode.black(nodePath[ i - 1].black());
                        nodePath[ i - 1].black(true);
                        wnode.right.black(true);
                        nodePath[ i - 1].right = wnode.left;
                        wnode.left = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        if (wnode.pred()) {
                            wnode.pred(false);
                            nodePath[ i - 1].succ(wnode);
                        }
                        break;
                    }
                } else {
                    Node wnode = nodePath[ i - 1].left;
                    if (!wnode.black()) {
                        wnode.black(true);
                        nodePath[ i - 1].black(false);
                        nodePath[ i - 1].left = wnode.right;
                        wnode.right = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        nodePath[ i] = nodePath[ i - 1];
                        dirPath[ i] = true;
                        nodePath[ i - 1] = wnode;
                        if (maxDepth == i++) {
                            maxDepth++;
                        }
                        wnode = nodePath[ i - 1].left;
                    }
                    if ((wnode.pred() || wnode.left.black())
                            && (wnode.succ() || wnode.right.black())) {
                        wnode.black(false);
                    } else {
                        if (wnode.pred() || wnode.left.black()) {
                            Node ynode = wnode.right;
                            ynode.black(true);
                            wnode.black(false);
                            wnode.right = ynode.left;
                            ynode.left = wnode;
                            wnode = nodePath[ i - 1].left = ynode;
                            if (wnode.pred()) {
                                wnode.pred(false);
                                wnode.left.succ(wnode);
                            }
                        }
                        wnode.black(nodePath[ i - 1].black());
                        nodePath[ i - 1].black(true);
                        wnode.left.black(true);
                        nodePath[ i - 1].left = wnode.right;
                        wnode.right = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        if (wnode.succ()) {
                            wnode.succ(false);
                            nodePath[ i - 1].pred(wnode);
                        }
                        break;
                    }
                }
            }
            if (tree != null) {
                tree.black(true);
            }
        }
        count--;
        // We clean up the node path, or we could have stale references later.
        while (maxDepth-- != 0) {
            nodePath[ maxDepth] = null;
        }
        return true;
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean contains(int k) {
        return findNode(k) != null;
    }

    @Override
    public void clear() {
        count = 0;
        tree = null;
        firstEntry = lastEntry = null;
    }

    @Override
    public int size() {
        return count;
    }

    @Override
    public boolean isEmpty() {
        return count == 0;
    }

    @Override
    public int firstInt() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return firstEntry.key;
    }

    @Override
    public int lastInt() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return lastEntry.key;
    }
	
    @Override
    public IntListIterator iterator() {
        return new TreeIterator();
    }

    @Override
    public IntListIterator iterator(int from) {
        return new TreeIterator(from);
    }

	@Override
	protected IntSortedSet subset(int begin, boolean bottom, int end, boolean top) {
		return new Subset(begin, bottom, end, top);
	}
	
    private void writeObject(java.io.ObjectOutputStream ostream) throws java.io.IOException {
        int n = count;
        TreeIterator iterator = new TreeIterator();
        ostream.defaultWriteObject();
        while (n-- != 0) {
            ostream.writeInt(iterator.nextInt());
        }
    }

    /**
     * Reads the given number of entries from the input stream, returning the
     * corresponding tree.istream@param s the input stream.
     * @param n the (positive) number of entries to read.
     * @param pred the entry containing the key that preceeds the first key in
     * the tree.
     * @param succ the entry containing the key that follows the last key in the
     * tree.
     */
    @SuppressWarnings("unchecked")
    private Node readTree(java.io.ObjectInputStream istream, int n, Node pred, Node succ) throws java.io.IOException, ClassNotFoundException {
        if (n == 1) {
            final Node top = new Node(istream.readInt());
            top.pred(pred);
            top.succ(succ);
            top.black(true);
            return top;
        }
        if (n == 2) {
            /* We handle separately this case so that recursion will
             *always* be on nonempty subtrees. */
            final Node top = new Node(istream.readInt());
            top.black(true);
            top.right(new Node(istream.readInt()));
            top.right.pred(top);
            top.pred(pred);
            top.right.succ(succ);
            return top;
        }
        // The right subtree is the largest one.
        final int rightN = n / 2, leftN = n - rightN - 1;
        final Node top = new Node();
        top.left(readTree(istream, leftN, pred, top));
        top.key = istream.readInt();
        top.black(true);
        top.right(readTree(istream, rightN, top, succ));
        if (n + 2 == ((n + 2) & -(n + 2))) {
            top.right.black(false); // Quick test for determining whether n + 2 is a power of 2.
        }
        return top;
    }

    private void readObject(java.io.ObjectInputStream istream) throws java.io.IOException, ClassNotFoundException {
        istream.defaultReadObject();
        allocatePaths();
        if (count != 0) {
            tree = readTree(istream, count, null, null);
            Node entry;
            entry = tree;
            while (entry.left() != null) {
                entry = entry.left();
            }
            firstEntry = entry;
            entry = tree;
            while (entry.right() != null) {
                entry = entry.right();
            }
            lastEntry = entry;
        }
    }
	
	/**
     * This class represent an entry in a tree set.
     *
     * <P>We use the only "metadata", i.e., {@link Node#info}, to store
     * information about color, predecessor status and successor status.
     *
     * <P>Note that since the class is recursive, it can be considered
     * equivalently a tree.
     */
    protected static final class Node {

        /**
         * The the bit in this mask is true, the node is black.
         */
        private final static int BLACK_MASK = 1;
        /**
         * If the bit in this mask is true, {@link #right} points to a
         * successor.
         */
        private final static int SUCC_MASK = 1 << 31;
        /**
         * If the bit in this mask is true, {@link #left} points to a
         * predecessor.
         */
        private final static int PRED_MASK = 1 << 30;
        /**
         * The key of this entry.
         */
        int key;

        /**
		 * The pointers to the left and right subtrees.
		 */
		Node left;

		Node right;
        /**
         * This integers holds different information in different bits (see
         * {@link #SUCC_MASK}, {@link #PRED_MASK} and {@link #BLACK_MASK}).
         */
        int info;

        Node() {
        }

        /**
         * Creates a new red entry with the given key.
         *
         * @param k a key.
         */
        Node(int k) {
            this.key = k;
            info = SUCC_MASK | PRED_MASK;
        }

        /**
         * Returns the left subtree.
         *
         * @return the left subtree (<code>null</code> if the left subtree is
         * empty).
         */
        Node left() {
            return (info & PRED_MASK) != 0 ? null : left;
        }

        /**
         * Returns the right subtree.
         *
         * @return the right subtree (<code>null</code> if the right subtree is
         * empty).
         */
        Node right() {
            return (info & SUCC_MASK) != 0 ? null : right;
        }

        /**
         * Checks whether the left pointer is really a predecessor.
         *
         * @return true if the left pointer is a predecessor.
         */
        boolean pred() {
            return (info & PRED_MASK) != 0;
        }

        /**
         * Checks whether the right pointer is really a successor.
         *
         * @return true if the right pointer is a successor.
         */
        boolean succ() {
            return (info & SUCC_MASK) != 0;
        }

        /**
         * Sets whether the left pointer is really a predecessor.
         *
         * @param pred if true then the left pointer will be considered a
         * predecessor.
         */
        void pred(boolean pred) {
            if (pred) {
                info |= PRED_MASK;
            } else {
                info &= ~PRED_MASK;
            }
        }

        /**
         * Sets whether the right pointer is really a successor.
         *
         * @param succ if true then the right pointer will be considered a
         * successor.
         */
        void succ(boolean succ) {
            if (succ) {
                info |= SUCC_MASK;
            } else {
                info &= ~SUCC_MASK;
            }
        }

        /**
         * Sets the left pointer to a predecessor.
         *
         * @param pred the predecessr.
         */
        void pred(Node pred) {
            info |= PRED_MASK;
            left = pred;
        }

        /**
         * Sets the right pointer to a successor.
         *
         * @param succ the successor.
         */
        void succ(Node succ) {
            info |= SUCC_MASK;
            right = succ;
        }

        /**
         * Sets the left pointer to the given subtree.
         *
         * @param left the new left subtree.
         */
        void left(Node left) {
            info &= ~PRED_MASK;
            this.left = left;
        }

        /**
         * Sets the right pointer to the given subtree.
         *
         * @param right the new right subtree.
         */
        void right(Node right) {
            info &= ~SUCC_MASK;
            this.right = right;
        }

        /**
         * Returns whether this node is black.
         *
         * @return true iff this node is black.
         */
        boolean black() {
            return (info & BLACK_MASK) != 0;
        }

        /**
         * Sets whether this node is black.
         *
         * @param black if true, then this node becomes black; otherwise, it
         * becomes red..
         */
        void black(boolean black) {
            if (black) {
                info |= BLACK_MASK;
            } else {
                info &= ~BLACK_MASK;
            }
        }

        /**
         * Computes the next entry in the set order.
         *
         * @return the next entry (<code>null</code>) if this is the last
         * entry).
         */
        Node next() {
            Node next = this.right;
            if ((info & SUCC_MASK) == 0) {
                while ((next.info & PRED_MASK) == 0) {
                    next = next.left;
                }
            }
            return next;
        }

        /**
         * Computes the previous entry in the set order.
         *
         * @return the previous entry (<code>null</code>) if this is the first
         * entry).
         */
        Node prev() {
            Node prev = this.left;
            if ((info & PRED_MASK) == 0) {
                while ((prev.info & SUCC_MASK) == 0) {
                    prev = prev.right;
                }
            }
            return prev;
        }

    }

    /**
     * An iterator on the whole range.
     *
     * <P>This class can iterate in both directions on a threaded tree.
     */
    protected class TreeIterator implements IntListIterator {

        /**
         * The entry that will be returned by the next call to
         * {@link java.util.ListIterator#previous()} (or
         * <code>null</code> if no previous entry exists).
         */
        Node prev;
        /**
         * The entry that will be returned by the next call to
         * {@link java.util.ListIterator#next()} (or
         * <code>null</code> if no next entry exists).
         */
        Node next;
        /**
         * The last entry that was returned (or
         * <code>null</code> if we did not iterate or used {@link #remove()}).
         */
        Node curr;
        /**
         * The current index (in the sense of a {@link java.util.ListIterator}).
         * Note that this value is not meaningful when this iterator has been
         * created using the nonempty constructor.
         */
        int index = 0;

        TreeIterator() {
            next = firstEntry;
        }

        TreeIterator(int k) {
            if ((next = locateNode(k)) != null) {
                if (compare(next.key, k) <= 0) {
                    prev = next;
                    next = next.next();
                } else {
                    prev = next.prev();
                }
            }
        }

        @Override
        public boolean hasNext() {
            return next != null;
        }

        @Override
        public boolean hasPrevious() {
            return prev != null;
        }

        void updateNext() {
            next = next.next();
        }

        Node nextEntry() {
            if (!hasNext()) {
                throw new NoSuchElementException();
            }
            curr = prev = next;
            index++;
            updateNext();
            return curr;
        }

        @Override
        public int nextInt() {
            return nextEntry().key;
        }

        @Override
        public int previousInt() {
            return previousEntry().key;
        }

        void updatePrevious() {
            prev = prev.prev();
        }

        Node previousEntry() {
            if (!hasPrevious()) {
                throw new NoSuchElementException();
            }
            curr = next = prev;
            index--;
            updatePrevious();
            return curr;
        }

        @Override
        public int nextIndex() {
            return index;
        }

        @Override
        public int previousIndex() {
            return index - 1;
        }

        @Override
        public void remove() {
            if (curr == null) {
                throw new IllegalStateException();
            }
            /* If the last operation was a next(), we are removing an entry that preceeds
             the current index, and thus we must decrement it. */
            if (curr == prev) { //NOPMD
                index--;
            }
            next = prev = curr;
            updatePrevious();
            updateNext();
            AIntRBTreeSet.this.remove(curr.key);
            curr = null;
        }
    }

    @SuppressFBWarnings("SE_INNER_CLASS")
    protected final class Subset extends ASubset implements java.io.Serializable {

        private static final long serialVersionUID = 1L;
        
        public Subset(int begin, boolean bottom, int end, boolean top) {
			super(begin, bottom, end, top);
        }

        @Override
        public IntListIterator iterator() {
            return new STreeIterator();
        }

        @Override
        public IntListIterator iterator(int from) {
            return new STreeIterator(from);
        }

        /**
         * Locates the first entry.
         *
         * @return the first entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AIntRBTreeSet.Node firstEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes to -infinity, we return the main set first entry; otherwise, we locate the start of the set.
            AIntRBTreeSet.Node entry;
            if (bottom) {
                entry = firstEntry;
            } else {
                entry = locateNode(begin);
                // If we find either the start or something greater we're OK.
                if (compare(entry.key, begin) < 0) {
                    entry = entry.next();
                }
            }
            // Finally, if this subset doesn't go to infinity, we check that the resulting key isn't greater than the end.
            if (entry == null || !top && compare(entry.key, end) >= 0) {
                return null;
            }
            return entry;
        }

        /**
         * Locates the last entry.
         *
         * @return the last entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AIntRBTreeSet.Node lastEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes to infinity, we return the main set last entry; otherwise, we locate the end of the set.
            AIntRBTreeSet.Node entry;
            if (top) {
                entry = lastEntry;
            } else {
                entry = locateNode(end);
                // If we find something smaller than the end we're OK.
                if (compare(entry.key, end) >= 0) {
                    entry = entry.prev();
                }
            }
            // Finally, if this subset doesn't go to -infinity, we check that the resulting key isn't smaller than the start.
            if (entry == null || !bottom && compare(entry.key, begin) < 0) {
                return null;
            }
            return entry;
        }

        @Override
        public int firstInt() {
            AIntRBTreeSet.Node entry = firstEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        @Override
        public int lastInt() {
            AIntRBTreeSet.Node entry = lastEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        private final class STreeIterator extends TreeIterator {

            STreeIterator() {
                next = firstEntry();
            }

            STreeIterator(int k) {
                this();
                if (next != null) {
                    if (!bottom && compare(k, next.key) < 0) {
                        prev = null;
                    } else if (!top && compare(k, (prev = lastEntry()).key) >= 0) {
                        next = null;
                    } else {
                        next = locateNode(k);
                        if (compare(next.key, k) <= 0) {
                            prev = next;
                            next = next.next();
                        } else {
                            prev = next.prev();
                        }
                    }
                }
            }

            @Override
            void updatePrevious() {
                prev = prev.prev();
                if (!bottom && prev != null && compare(prev.key, begin) < 0) {
                    prev = null;
                }
            }

            @Override
            void updateNext() {
                next = next.next();
                if (!top && next != null && compare(next.key, end) >= 0) {
                    next = null;
                }
            }
        }
    }

}
